Project Chrono: chrono::vehicle::ChChassisConnectorHitch Class Reference

Public Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChChassisConnectorHitch Class Reference
VEHICLE module

## Description

Template for a hitch chassis connector. This is a passive connector, modeled with a spherical joint.

`#include <ChChassisConnectorHitch.h>`

Inheritance diagram for chrono::vehicle::ChChassisConnectorHitch:
[legend]
Collaboration diagram for chrono::vehicle::ChChassisConnectorHitch:
[legend]

## Public Member Functions
| ChChassisConnectorHitch (const std::string &name)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual void | Initialize (std::shared_ptr< ChChassis > front, std::shared_ptr< ChChassisRear > rear) override
| Initialize this chassis connector subsystem.
Public Member Functions inherited from chrono::vehicle::ChChassisConnector
| ChChassisConnector (const std::string &name)
virtual void | Synchronize (double time, const DriverInputs &driver_inputs)
| Update the state of this connector subsystem at the current time.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis)
| Add visualization assets to this subsystem, for the specified visualization mode.
virtual void | RemoveVisualizationAssets ()
| Remove all visualization assets from this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Protected Attributes
std::shared_ptr< ChLinkLockSpherical > | m_joint
| spherical joint of the connector
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChChassisConnectorHitch::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ Initialize()

void chrono::vehicle::ChChassisConnectorHitch::Initialize | ( | std::shared_ptr< ChChassis > | front,
|  | std::shared_ptr< ChChassisRear > | rear )
| overridevirtual

Initialize this chassis connector subsystem.

The subsystem is initialized by attaching it to the specified front and rear chassis bodies at the specified location (with respect to and expressed in the reference frame of the front chassis).

Parameters

  [in] | front | front chassis
  [in] | rear | rear chassis

Reimplemented from chrono::vehicle::ChChassisConnector.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/chassis/ChChassisConnectorHitch.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/chassis/ChChassisConnectorHitch.cpp